## file: Rcodes-chap01-intro.r
## usage: source('Rcodes-chap01-intro.r',echo=TRUE,max.deparse.length=Inf)
## demo(graphics)    # graphics に関するデモを (表示は省略)
## q()
## install.packages(’kernlab’) # インストール (表示は省略)
## library(kernlab)            # 今度はエラーは出ない
msg <- "------------------------ Type  <Return> to continue ------------------------: "

search()
readline(msg)
## ?Arithmetic      # 基本的な演算のマニュアル
## ?Comparison      # 比較演算子のマニュアル
## ?base::Logic     # 論理演算子のマニュアル

readline(msg)
1-2; 10^2 * 1e-3 * 1.23e2
0^0                # pythonとは異なるので注意
1/Inf              # Infは無限大
pi                 # 円周率
options(digits=22) # 表示桁数の変更
pi

options(digits=8) 
readline(msg)
1==1
1!=1
Inf==Inf
-Inf<1 & 1<Inf     #  AND演算子

readline(msg)
##(2<1) & a            # 使われていない変数 a も評価される(エラーになる)
(2<1) && a;            # 2<1 が FALSE なので変数 a は評価されない
##(2>1) | v            # 使われていない変数 v も評価される(エラーになる)
(2>1) || v;            # 2>1 が TRUE なので変数 v は評価されない


readline(msg)
## ベクトルと行列
x <- c(4,-1)      # xにベクトル(4,-1)を代入
-3:4              # -3から4までの整数を要素にもつベクトル
## ベクトルを行方向に結合して行列を生成
rbind(c(1,2),c(3,4)) 
X <- cbind(c(1,2),c(3,4))   # 列ベクトルとして結合
rbind(X,c(-1,-2)); X        # 行列とベクトルを行方向に結合


readline(msg)
A <- matrix(1:12,3,4)       # 要素とサイズを指定して行列を生成
A
dim(A)                      # A のサイズ
array(1:18,dim=c(2,3,3))  


readline(msg)
v <- rep(1:5,3)                  # ベクトルvを生成
v
v[3]                             # 第3要素
v[3:8]                           # 第3要素から第8要素
which(v==2)                      # 2に等しいのはv[2],v[7],v[12]
v[which(v==2)]
A <- matrix(1:12,3,4)            # 行列A
A[2,]                            # 第2行
A[,c(2,4)]                       # 第2,4列
A[2,4]                           # (2,4)成分


readline(msg)
## 
A[,4]
A[,4,drop=FALSE]
A[2,,drop=FALSE]


readline(msg)
##
a <- list(2:5, matrix(1:12,3,4), letters)  # リストのデータを定義
length(a)    
a                                          # a の要素を表示
a[1]      # a の1番目の要素．返り値はリスト
a[[1]]    # a の1番目の要素．返り値はベクトル


readline(msg)
##
b <- list(x=c(3,-1,2), y=3)   # リストを定義．要素に名前を付ける
b  
b$x
b[[1]]       #   b$x と同じ
b[1]         #   要素 x をリスト型で返す


readline(msg)
##
alphabet <- vector("list",26)  # 要素数26の(カラの)リスト
length(alphabet)               # 要素数26
names(alphabet) <- letters     # 26個の要素に各アルファベットで名前を付ける．
alphabet                       # 値を出力


readline(msg)
##
x <- matrix(rnorm(2*3),2)           # 2x3行列を作成. rnorm は乱数生成
d <- data.frame(x,LETTERS[2:3])     # 文字列型のデータを第4列に追加
d                                   # 1〜3列は数値，4列は文字列
m <- cbind(x,LETTERS[2:3])          # 行列のまま文字列を第4列に追加
m                                   # すべての要素のデータ型が変換される
## 有名なフィッシャーのiris(アヤメ)データ
iris[1:3,]                         # 第5列はファクター(因子)型


readline(msg)
##
A <- matrix(1:12,3,4)
B <- A %*% t(A)/100
diag(B) <- 1        # Bの対角行列に1を代入
d <- c(1,0,-1)      # ベクトル d を作成
solve(B,d)          # Bx=d を解く
solve(B,matrix(d))  # dを行列にしてBx=d を解く(結果は同じ)


readline(msg)
## 
ei <- eigen(B)       # 上の行列B固有値と固有ベクトルを計算
ei                   # 結果はリストで返される
ei$values             # 固有値のみ表示


readline(msg)
## 
a <- c(3,-2,4,1,9)                  # ベクトルaを生成
sum(a)                              # aの要素の総和
mean(a)                             # aの要素の平均
sqrt(2)                             # 2の平方根
sqrt(5:8)                           # sqrtをベクトル (5,6,7,8) に適用
log(matrix(1:12,3))                 # logを行列に適用


readline(msg)
## 関数定義: parity．入力 x は double 型
parity <- function(x){
  if(x%%2==0){     # ifで条件分岐
    print('偶数')
  }else if(x%%2==1){
    print('奇数')
  }else {
    print('整数でない')
  }
}
parity(2)
parity(-3)
parity(pi)


readline(msg)
## for の構文(出力は省略)．
s <-0; for(i in 1:10){# 1から10までの和を計算
  s <- s+i
  print(s)
}
s==sum(1:10)          # sumを使えば同じ計算ができる
## 同じ計算を while で実行 
i <- 1; s <-0; while(i<=10){
  s <- s+i
  i <- i+1
}
s


readline(msg)
## ?Control  # for, while など制御コマンドのマニュアル


readline(msg)
## ## ファイル名 Rcode-parity.r で保存
## parity <- function(x){
##   if(x%%2==0){           # ifで条件分岐
##     print('偶数')
##   }else if(x%%2==1){
##     print('奇数')
##   }else {
##     print('整数でない')
##   }
## }
## source('Rcode-parity.r')    # Rcode-parity.r を読込み
## parity(3)                   # parity関数を実行


readline(msg)
## プロット
plot(iris[,-5])


readline(msg)
x <- matrix(rnorm(50*3),50)  # 行列を作成
plot(x)                      # 行列を与えてプロット


readline(msg)
plot(data.frame(x))          # データフレームを与えてプロット


readline(msg)
curve(sin(x),xlim=c(-3,3))  # curve関数で sin(x) を表示


readline(msg)
## 同じ関数を plot で表示
x <- seq(-3,3,l=100)        # -3から3まで等間隔に100個の点をとる
plot(x,sin(x),type='l')     # sin(x)をプロット


readline(msg)
x <- rnorm(100); y <- sin(x)         # 乱数でデータを生成
plot(x,y,type='l')                   # typeを'line'に指定してプロット


readline(msg)
plot(sort(x),y[order(x)],type='l')   # データをソートしてプロット


readline(msg)
## ?plot            # plotのマニュアル
## ?plot.default    # 詳しいマニュアル
