## file: Rcodes-chap02-prob.r
## usage: source('Rcodes-chap02-prob.r',echo=TRUE,max.deparse.length=Inf)
msg <- "------------------------ Type  <Return> to continue ------------------------: "


## sample 関数
sample(1:6,10,replace=TRUE)
sample(1:6,10,replace=TRUE)
## sample(1:6,10)
##  sample.int(length(x), size, replace, prob) でエラー:
##  'replace = FALSE' なので、母集団以上の大きさの標本は取ることができません 

sample(1:6,5)
sample(1:6,20,replace=TRUE,prob=c(1,1,1,3,3,3))


readline(msg)
## 期待値と分散
# 期待値1，標準偏差2の正規分布にしたがうデータを100個生成
x <- rnorm(100,mean=1,sd=2)
mean(x)  # データの平均値を計算
sd(x)    # データの標準偏差を計算
# |x-E[x]]| ≦ sd(x) となるデータの割合
mean(abs(x-mean(x))<=sd(x))
# |x-E[x]]| ≦ 2*sd(x) となるデータの割合
mean(abs(x-mean(x))<=2*sd(x))


readline(msg)
## 分位点
qnorm(0.7)  # N(0,1)の0.7点
# N(1,2^2)の0.7点
qnorm(0.7,mean=1,sd=2)
alpha <- 0.05
qnorm(1-alpha)                    # N(0,1)の上側0.05点
qnorm(alpha, lower.tail=FALSE)    # N(0,1)の上側0.05点


readline(msg)
## 分散共分散行列
iris                          # iris データの表示
cor(iris[,c(1,2)])            # Sepal.LengthとSepal.Widthの相関係数行列
var(iris[,c(1,2)])            # 分散共分散行列
cor(iris[,c(1,3)])            # Sepal.LengthとPetal.Lengthの相関係数行列


readline(msg)
plot(iris[,c(1,2)])           # Sepal.LengthとSepal.Widthのプロット


readline(msg)
plot(iris[,c(1,3)])           # Sepal.LengthとPetal.Lengthのプロット
