## file: Rcodes-chap07-test.r
## usage: source('Rcodes-chap07-test.r',echo=TRUE,max.deparse.length=Inf)
msg <- "------------------------ Type  <Return> to continue ------------------------: "


## t 検定
## 一標本検定
x <- rnorm(50,mean=1.1)                # データ生成
t.test(x,mu=1,alternative='two.sided') # 両側検定(データ数 50)


readline(msg)
x <- rnorm(100,mean=1.1)               # データ生成(データ数 100)
t.test(x,mu=1,alternative='two.sided') # 両側検定(データ数 100)
readline(msg)
t.test(x,mu=1,alternative='greater')   # 片側検定：greater(データ数 100)

readline(msg)
## 二標本検定
## データ生成：期待値は異なる．分散は同じ
mu1 <- 1.1; mu2 <- 1
x <- rnorm(1000,mean=mu1)
y <- rnorm(200, mean=mu2)
t.test(x,y,alternative='two.sided')  ## 両側検定：two.side


readline(msg)
t.test(x,y,alternative='greater')    ## 片側検定：greater


readline(msg)
## ウィルコクソン検定(二標本検定)

## 同じ分布にしたがう標本
mu1 <- 1; mu2 <- 1
x <- rnorm(500,mean=mu1)
y <- rnorm(300,mean=mu2)
wilcox.test(x,y)                       ## ウィルコクソン検定


readline(msg)
## ウィルコクソン検定(二標本検定)
## 期待値は同じ，分散は異なる標本
mu1 <- 1; mu2 <- 1
x <- rnorm(500,mean=mu1,sd=2)
y <- rnorm(300,mean=mu2)
wilcox.test(x,y)                       ## ウィルコクソン検定


readline(msg)
## ウィルコクソン検定(二標本検定)
## 異なる期待値の分布にしたがう標本
mu1 <- 1.2; mu2 <- 1
x <- rnorm(500,mean=mu1)
y <- rnorm(300,mean=mu2)   
wilcox.test(x,y)                       ## ウィルコクソン検定


readline(msg)
## コルモゴロフ・スミルノフ検定
## 同じ分布にしたがう標本
mu1 <- 1; mu2 <- 1
x <- rnorm(500,mean=mu1)
y <- rnorm(300,mean=mu2)
ks.test(x,y)                           ## コルモゴロフ・スミルノフ検定

readline(msg)
## コルモゴロフ・スミルノフ検定
## 期待値は同じ，分散は異なる標本
mu1 <- 1; mu2 <- 1
x <- rnorm(500,mean=mu1,sd=2)
y <- rnorm(300,mean=mu2)
ks.test(x,y)                           ## コルモゴロフ・スミルノフ検定


readline(msg)
## コルモゴロフ・スミルノフ検定
## 異なる期待値の分布に対する両側検定
mu1 <- 1.2; mu2 <- 1
x <- rnorm(500,mean=mu1)
y <- rnorm(300,mean=mu2)
ks.test(x,y)                           ## コルモゴロフ・スミルノフ検定(両側検定)
## 異なる期待値の分布に対する片側検定
ks.test(x,y,alternative="less")        ## コルモゴロフ・スミルノフ検定(片側検定)


readline(msg)
## 分散分析
## 帰無仮説が正しいとき
x  <- rnorm(50)         # データ生成
gr <- gl(5, 10)         # 水準数は5，各水準で10データ
anova(aov(x~gr))        # 分散分析


readline(msg)
## 帰無仮説は間違いのとき
x  <- c(rnorm(100), rnorm(20,mean=0.7)) # データ数120のデータ生成
gr <- gl(6,20)                          # 水準数は6，各水準で20データ
anova(aov(x~gr))                        # 分散分析


readline(msg)
## iris データに分散分析を適用：Species(品種)とSepal.Length(ガクの長さ)
anova(aov(iris$Sepal.Length ~ iris$Species))
